/*
    Copyright (C) 2012  Leonardo Pozzati
    This file is part of MetastableRandWalk.

    MetastableRandWlak is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    MetastableRandWalk is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Nome-Programma.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _MYPARSELIB_H
#define _MYPARSELIB_H

#include <iostream>
#include <cstdlib>
#include <map>
#include <vector>
#include <algorithm>


//banali funzioni di stampa
void showVect(std::vector<std::string>, std::string);
void showMap1(std::map<std::string, unsigned>, std::string);
void showMap2(std::map<std::string, std::string>, std::string);

/* copia in un vector (e lo ritorna) gli elementi delle due string []
 * di default la seconda è NULL e l'int relativo è 0
 */
std::vector<std::string>
arrayToVector(std::string [], int, std::string [], int);

/* copia in un vector (e lo ritorna) gli elementi in string
 * tra il primo e il secondo string.
 * Se non trova il primo (il secondo) copia dall'inizio (fino alla fine)
 */
std::vector<std::string>
arrayRangeToVector(std::string [], int, std::string, std::string);

/* Inserisce nella map passata, modificandola,
 * la string passata, se non è già presente.
 */
void mapSecureInsert(std::map<std::string, unsigned> &, std::string);

/* Inserisce nella vector passato, modificandolo,
 * la string passata, se non è già presente.
 */
void vectorSecureInsert(std::vector<std::string> &, std::string);

/* Il cuore del programma e dello scan dei parametri
 * Commentato nella definizione
 */
std::map<std::string, std::string>
inputScan(std::string [], int,std::string [], int,char *[], int);

#endif
